﻿/*-------------------------------------------------------------------------
 SASEBO Cipher Module; LSI GAIA(130nm) and CHAR(90nm)
 
 File name   : Tracer.cs
 Version     : Version 1.1
 Created     : Apr/20/2009
 Last update : Aug/18/2009
 Desgined by : Toshihiro Katashita
 
 
 Copyright (C) 2009 AIST
 
 By using this code, you agree to the following terms and conditions.
 
 This code is copyrighted by AIST ("us").
 
 Permission is hereby granted to copy, reproduce, redistribute or
 otherwise use this code as long as: there is no monetary profit gained
 specifically from the use or reproduction of this code, it is not sold,
 rented, traded or otherwise marketed, and this copyright notice is
 included prominently in any copy made.
 
 We shall not be liable for any damages, including without limitation
 direct, indirect, incidental, special or consequential damages arising
 from the use of this code.
 
 When you publish any results arising from the use of this code, we will
 appreciate it if you can cite our webpage
 (http://www.rcis.aist.go.jp/special/SASEBO/).
 -------------------------------------------------------------------------*/ 

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Diagnostics;

namespace SASEBO_Checker_AES
{
	//================================================================ Tracer_LSI_rev1
  class Tracer_LSI_rev1 : Tracer
  {
		//************************************************ Variable
    SASEBO.CipherModule_rev1 module;
    //# int num_trace;
    int num_hash;
    //# byte[] key;
    byte[] message;
    int hash_loop; //#
    int check_latency;
    int data_size;

		//************************************************ Method
		//------------------------------------------------ Constructor
        //public Tracer_LSI_rev1(SASEBO.CipherModule module, int num_trace, string key_st)
    public Tracer_LSI_rev1(SASEBO.CipherModule module, int num_hash, string message_st, int hash_loop, int check_latency, int data_size)
    {
        this.module = (SASEBO.CipherModule_rev1)module;
        //# this.num_trace = num_trace;
        this.num_hash = num_hash;
        this.hash_loop = hash_loop;
        this.check_latency = check_latency;
        this.data_size = data_size;

        //# key = new byte[16];
        //# for (int i=0; i<16; i++) key[i] = Convert.ToByte(key_st.Substring(i * 3, 2), 16);

        //# key = new byte[64];
        //# for (int i = 0; i < 64; i++) key[i] = Convert.ToByte(key_st.Substring(i * 3, 2), 16);

        //message = new byte[4]; //# 32 bit
        //for (int i = 0; i < 4; i++) message[i] = Convert.ToByte(message_st.Substring(i * 3, 2), 16);
        
        //message = new byte[16]; //# 128 bit
        //for (int i = 0; i < 16; i++) message[i] = Convert.ToByte(message_st.Substring(i * 3, 2), 16);
        
        //message = new byte[32]; //# 256 bit
        //for (int i = 0; i < 32; i++) message[i] = Convert.ToByte(message_st.Substring(i * 3, 2), 16);
        
        //message = new byte[48]; //# 384 bit
        //for (int i = 0; i < 48; i++) message[i] = Convert.ToByte(message_st.Substring(i * 3, 2), 16);
        
        //message = new byte[64]; //# 512 bit
        //for (int i = 0; i < 64; i++) message[i] = Convert.ToByte(message_st.Substring(i * 3, 2), 16);

        message = new byte[data_size];
        for (int i = 0; i < data_size; i++) message[i] = Convert.ToByte(message_st.Substring(i * 3, 2), 16);

        worker = new BackgroundWorker();
        worker.WorkerReportsProgress = true;
        worker.WorkerSupportsCancellation = true;
        worker.DoWork += new DoWorkEventHandler(worker_DoWork);
    }


		//************************************************ BackgroudWorker
		//------------------------------------------------ worker_DoWork()
    private void worker_DoWork(object sender, DoWorkEventArgs e)
    {
        e.Cancel = false;

        SASEBO.CipherCore core = module.cores[0];
        Cipher.CipherInterface cipher = null;
        cipher = (Cipher.CipherInterface)Activator.CreateInstance(Type.GetType("Cipher." + core.method, true));

        int progress = 0;
        e.Cancel = trace_loop_block(core, cipher, ref progress);
    }


		//------------------------------------------------ trace_loop_block()
    private bool trace_loop_block(SASEBO.CipherCore core, Cipher.CipherInterface cipher, ref int progress)
    {
      Random rand = new Random();

      //# modified by Kobayashi.
      //int ksize = cipher.getKeyWidth();
      //int dsize = cipher.getDatWidth();
      //int ksize = 64;

      //int idsize = 4; //# 32 bit
      //int idsize = 16; //# 128 bit
      //int idsize = 32; //# 256 bit
      //int idsize = 48; //# 384 bit
      //int idsize = 64; //# 512 bit
      
      int odsize = 32;
      //int loop;
      bool error = false;
      int EOM = 0x0000;
      
      //byte[] text_in = new byte[dsize];
      //byte[] text_out = new byte[dsize];
      //byte[] text_ans = new byte[dsize];
      //byte[] text_in  = new byte[idsize];
      byte[] text_in = new byte[data_size];
      byte[] text_out = new byte[odsize];
      //byte[] text_ans = new byte[] {0xba,0x78,0x16,0xbf,0x8f,0x01,0xcf,0xea,0x41,0x41,0x40,0xde,0x5d,0xae,0x22,0x23,0xb0,0x03,0x61,0xa3,0x96,0x17,0x7a,0x9c,0xb4,0x10,0xff,0x61,0xf2,0x00,0x15,0xad};
      //byte[] text_ans = new byte[odsize]; //need to modify
      //byte[] text_ans = new byte[2]; //need to modify
      byte[] text_latency_core = new byte[2]; //need to modify
      byte[] text_latency_all = new byte[2]; //need to modify
      byte[] text_zero = new byte[] { 0x00, 0x03 };
      
      if (hash_loop == 1)
      {
      //for (loop = 0; loop < num_hash; loop++)
      //{
          // Initialization
          module.select(core.id);
          //# module.encdec(module.MODE_ENC);
          //# module.key(key, 16); // Hardware
          //# cipher.setkey(key);  // Software

          // Main loop
          progress = 0;
          //# worker.ReportProgress(progress, (object)(new TracerReport(core.name + "...\t", 0, key, (byte[])null, text_in, text_out, text_ans)));
          worker.ReportProgress(progress, (object)(new TracerReport(core.name + "...\t", 0, message, (byte[])null, text_in, text_out, text_latency_core, text_latency_all)));
      }
      
      
        //progress = (int)(100.0d * loop / num_trace);
        //if (loop == num_hash) EOM = 0x0010;
        if (hash_loop == num_hash) EOM = 0x0010;
      
        progress = (int)(100.0d * hash_loop / num_hash);

        //send next 512 bit message.
        text_in = message; // need to modify
        //# how to update the message?
        //module.next_write(text_in, idsize, EOM, check_latency);
        module.next_write(text_in, data_size, EOM, check_latency);
        //# modified by Kobayashi.
        //# polling.
        //1 while (module.lbus.read(ADDR_CONT) != 0x0000) { /*nop*/ } //# polling.
                                                           //# wait while, ctrl[1] = 1.
        // Cryptographic processing
        //3 module.write(text_in, idsize);

        //module.read(text_out, odsize);
        //if ((loop + 1) == num_trace) module.read(text_out, odsize);
        //if ((loop + 1) == num_hash) module.read(text_out, odsize);
        if (hash_loop == num_hash) {
            if (check_latency == 1) {
                module.read2(text_out, text_latency_core, text_latency_all, odsize, EOM, data_size);
            }
            else {
                module.read(text_out, odsize, EOM, data_size);
                text_latency_core = text_zero;
                text_latency_all = text_zero;
            }
        }
        
        // Check result
        //error = false; //error is always false. by Kobayashi
        //for (int i = 0; i < odsize; i++) if (text_out[i] != text_ans[i]) error = true;
        //worker.ReportProgress(progress, (object)(new TracerReport("", loop, key, (byte[])null, text_in, text_out, text_ans)));
        //test_ans = cipher.compute(text_in); //# need to modify
        //# worker.ReportProgress(progress, (object)(new TracerReport("", trace_loop, key, (byte[])null, text_in, text_out, text_ans)));
        worker.ReportProgress(progress, (object)(new TracerReport("", hash_loop, message, (byte[])null, text_in, text_out, text_latency_core, text_latency_all)));

        // Caceled ?
        //if (worker.CancellationPending || error) break;
      //} //endof loop

      if (worker.CancellationPending || error) error = true;

      String result;
      if (error) result = "ng.\r\n";
      else       result = "ok.\r\n";
      //worker.ReportProgress(progress, (object)(new TracerReport(result, loop, key, (byte[])null, text_in, text_out, text_ans)));
      worker.ReportProgress(progress, (object)(new TracerReport(result, hash_loop, message, (byte[])null, text_in, text_out, text_latency_core, text_latency_all)));

      return error;
    }
  }
}
